import { ProxyEmitter } from 'smart-table-events';
import { FilterConfiguration, FilterOperator } from 'smart-table-filter';
import { SmartTable } from './table';
interface FilterProxy extends ProxyEmitter {
    onFilterChange(listener: FilterChangeCallback): FilterDirective;
}
export { FilterConfiguration, FilterOperator } from 'smart-table-filter';
export interface FilterChangeCallback {
    (filterState: FilterConfiguration): void;
}
export interface FilterDirective extends FilterProxy {
    filter<K>(input?: K): void;
    state(): FilterConfiguration;
}
export declare const enum FilterType {
    BOOLEAN = "boolean",
    NUMBER = "number",
    DATE = "date",
    STRING = "string"
}
export interface FilterDirectiveConfiguration<T> {
    table: SmartTable<T>;
    pointer: string;
    operator?: FilterOperator;
    type?: FilterType;
}
export declare const filterDirective: <T>({ table, pointer, operator, type }: FilterDirectiveConfiguration<T>) => FilterDirective;
