import { ProxyEmitter } from 'smart-table-events';
import { SmartTable } from './table';
import { SummaryDirective } from './summary';
import { SliceConfiguration } from '../slice';
export interface PageChangeCallback {
    (sliceState: SliceConfiguration): void;
}
interface PaginationProxy extends SummaryDirective, ProxyEmitter {
    onPageChange(listener: PageChangeCallback): any;
}
export interface PaginationDirective extends PaginationProxy {
    selectPage(p: number): void;
    selectNextPage(): void;
    selectPreviousPage(): void;
    isPreviousPageEnabled(): boolean;
    isNextPageEnabled(): boolean;
    changePageSize(size: number): void;
    state(): SliceConfiguration;
}
export interface PaginationDirectiveConfiguration<T> {
    table: SmartTable<T>;
}
export declare const paginationDirective: <T>({ table }: PaginationDirectiveConfiguration<T>) => PaginationDirective;
export {};
