import { ProxyEmitter } from 'smart-table-events';
import { SmartTable } from './table';
import { SearchConfiguration } from 'smart-table-search';
interface SearchProxy extends ProxyEmitter {
    onSearchChange(listener: SearchChangeCallback): SearchDirective;
}
export { SearchConfiguration } from 'smart-table-search';
export interface SearchChangeCallback {
    (searchState: SearchConfiguration): void;
}
export interface SearchDirective extends SearchProxy {
    search(input: string, opts?: object): void;
    state(): SearchConfiguration;
}
export interface SearchDirectiveConfiguration<T> {
    table: SmartTable<T>;
    scope: string[];
}
export declare const searchDirective: <T>({ table, scope }: SearchDirectiveConfiguration<T>) => SearchDirective;
