import { ProxyEmitter } from 'smart-table-events';
import { SmartTable } from './table';
import { SortDirection } from 'smart-table-sort';
export { SortDirection } from 'smart-table-sort';
export interface SortConfiguration {
    pointer?: string;
    direction?: SortDirection;
}
export interface SortChangeCallback {
    (state: SortConfiguration): void;
}
interface SortProxy extends ProxyEmitter {
    onSortToggle(listener: SortChangeCallback): SortDirective;
}
export interface SortDirective extends SortProxy {
    toggle(): void;
    state(): SortConfiguration;
}
export interface SortDirectiveConfiguration<T> {
    table: SmartTable<T>;
    pointer: string;
    cycle?: boolean;
    debounceTime?: number;
}
export declare const sortDirective: <T>({ pointer, table, cycle, debounceTime }: SortDirectiveConfiguration<T>) => SortDirective;
