import { FilterConfiguration } from 'smart-table-filter';
import { SmartTable, TableState } from './directives/table';
import { SearchConfiguration } from 'smart-table-search';
import { SortConfiguration } from './directives/sort';
export interface SmartTableInput<T> {
    sortFactory?: (conf: SortConfiguration) => (items: T[]) => T[];
    filterFactory?: (conf: FilterConfiguration) => (items: T[]) => T[];
    searchFactory?: (conf: SearchConfiguration) => (items: T[]) => T[];
    tableState?: TableState;
    data?: T[];
}
export interface SmartTableExtensionInput<T> extends SmartTableInput<T> {
    table: SmartTable<T>;
}
export interface SmartTableExtension<T> {
    (input: SmartTableExtensionInput<T>): any;
}
export declare const smartTable: <T>({ sortFactory, filterFactory, searchFactory, tableState, data }?: SmartTableInput<T>, ...tableExtensions: SmartTableExtension<T>[]) => SmartTable<T>;
export * from './directives/filter';
export * from './directives/search';
export * from './directives/pagination';
export * from './directives/sort';
export * from './directives/summary';
export * from './directives/table';
export * from './directives/working-indicator';
export * from './slice';
